Object subclass: #ODE
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ODE'!

!ODE methodsFor: 'accessing' stamp: 'tak 6/27/2004 19:41'!
dBodyGetAngularVel: bodyID 
	| answer |
	answer _ self newVector3.
	self primDBodyGetAngularVel: bodyID into: answer.
	^ answer! !

!ODE methodsFor: 'accessing' stamp: 'tak 6/28/2004 23:41'!
dBodyGetLinearVel: bodyID 
	| answer |
	answer _ self newVector3.
	self primDBodyGetLinearVel: bodyID into: answer.
	^ answer! !

!ODE methodsFor: 'accessing' stamp: 'tak 6/27/2004 19:41'!
dBodyGetPosition: bodyID 
	| answer |
	answer _ self newVector3.
	self primDBodyGetPosition: bodyID into: answer.
	^ answer! !

!ODE methodsFor: 'accessing' stamp: 'tak 6/28/2004 11:27'!
dBodyGetQuaternion: bodyID 
	| answer |
	answer _ FloatArray with: 0 with: 0 with: 0 with: 0.
	self primDBodyGetQuaternion: bodyID into: answer.
	^ answer! !

!ODE methodsFor: 'accessing' stamp: 'tak 6/28/2004 17:09'!
dJointGroupEmpty: jointGroupID 
	self primDJointGroupEmpty: jointGroupID 
! !

!ODE methodsFor: 'accessing' stamp: 'tak 6/28/2004 17:08'!
dWorldQuickStep: worldID with: stepSize
	self primDWorldQuickStep: worldID with: stepSize! !

!ODE methodsFor: 'accessing' stamp: 'tak 6/27/2004 19:41'!
newVector3
	^ FloatArray with: 0 with: 0 with: 0! !


!ODE methodsFor: 'collision' stamp: 'tak 6/27/2004 15:29'!
dSpaceCollide: space do: aBlock 
	"enumerate with geomID1 and geomID2"
	| geoms |
	geoms _ self primDSpaceCollide: space.
	1
		to: geoms size
		by: 2
		do: [:i | aBlock value: (geoms at: i) value: (geoms at: i + 1)]! !


!ODE methodsFor: 'primitive geom' stamp: 'tak 6/28/2004 14:49'!
primDCreateBox: spaceID with: x with: y with: z
	<primitive: 'primitiveDCreateBox' module: 'ODEPlugin'>
	^ self primitiveFailed! !

!ODE methodsFor: 'primitive geom' stamp: 'tak 6/27/2004 18:35'!
primDCreatePlane: spaceID with: a with: b with: c with: d 
	<primitive: 'primitiveDCreatePlane' module: 'ODEPlugin'>
	^ self primitiveFailed! !

!ODE methodsFor: 'primitive geom' stamp: 'tak 6/27/2004 18:35'!
primDCreateSphere: spaceId with: radius
	<primitive: 'primitiveDCreateSphere' module: 'ODEPlugin'>
	^ self primitiveFailed! !

!ODE methodsFor: 'primitive geom' stamp: 'tak 6/28/2004 14:48'!
primDGeomBoxSetLengths: geomID with: x with: y with: z
	<primitive: 'primitiveDGeomBoxSetLengths' module: 'ODEPlugin'>
	^ self primitiveFailed! !

!ODE methodsFor: 'primitive geom' stamp: 'tak 6/27/2004 18:35'!
primDGeomDestroy: geomID
	<primitive: 'primitiveDGeomDestroy' module: 'ODEPlugin'>
	^ self primitiveFailed! !

!ODE methodsFor: 'primitive geom' stamp: 'tak 6/27/2004 18:35'!
primDGeomSetBody: geomId with: bodyId
	<primitive: 'primitiveDGeomSetBody' module: 'ODEPlugin'>
	^ self primitiveFailed! !

!ODE methodsFor: 'primitive geom' stamp: 'tak 6/28/2004 01:41'!
primDGeomSphereSetRadius: geomID with: radius
	<primitive: 'primitiveDGeomSphereSetRadius' module: 'ODEPlugin'>
	^ self primitiveFailed! !


!ODE methodsFor: 'primitive collision ' stamp: 'tak 6/27/2004 18:35'!
primDHashSpaceCreate: spaceID
	"spaceID is a dSpaceID or zero"
	<primitive: 'primitiveDHashSpaceCreate' module: 'ODEPlugin'>
	^ self primitiveFailed! !

!ODE methodsFor: 'primitive collision ' stamp: 'tak 6/27/2004 18:35'!
primDJointDestroy: jointID
	<primitive: 'primitiveDJointDestroy' module: 'ODEPlugin'>
	^ self primitiveFailed! !

!ODE methodsFor: 'primitive collision ' stamp: 'tak 6/27/2004 18:35'!
primDJointGroupCreate
	<primitive: 'primitiveDJointGroupCreate' module: 'ODEPlugin'>
	^ self primitiveFailed! !

!ODE methodsFor: 'primitive collision ' stamp: 'tak 6/27/2004 18:35'!
primDJointGroupDestroy:  jointGoupId 
	<primitive: 'primitiveDJointGroupDestroy' module: 'ODEPlugin'>
	^ self primitiveFailed! !

!ODE methodsFor: 'primitive collision ' stamp: 'tak 6/27/2004 18:35'!
primDSpaceCollide: spaceID 
	<primitive: 'primitiveDSpaceCollide' module: 'ODEPlugin'>
	^ self primitiveFailed! !

!ODE methodsFor: 'primitive collision ' stamp: 'tak 6/27/2004 18:35'!
primDSpaceDestroy: spaceId 
	<primitive: 'primitiveDSpaceDestroy' module: 'ODEPlugin'>
	^ self primitiveFailed! !

!ODE methodsFor: 'primitive collision ' stamp: 'tak 6/27/2004 18:35'!
primMakeContact: o1 with: o2 world: world group: group bounce: bounce bounceVel: bounceVel softCFM: softCFM 
	<primitive: 'primitiveMakeContact' module: 'ODEPlugin'>
	^ self primitiveFailed! !


!ODE methodsFor: 'primitives rigid ' stamp: 'tak 6/28/2004 23:38'!
primDBodyAddForce: bodyID with: x with: y with: z 
	<primitive: 'primitiveDBodyAddForce:' module: 'ODEPlugin'>
	self primitiveFailed! !

!ODE methodsFor: 'primitives rigid ' stamp: 'tak 6/28/2004 23:38'!
primDBodyAddTorque: bodyID with: x with: y with: z 
	<primitive: 'primitiveDBodyAddTorque' module: 'ODEPlugin'>
	self primitiveFailed! !

!ODE methodsFor: 'primitives rigid ' stamp: 'tak 6/27/2004 18:35'!
primDBodyCreate: worldHandle
	<primitive: 'primitiveDBodyCreate' module: 'ODEPlugin'>
	self primitiveFailed! !

!ODE methodsFor: 'primitives rigid ' stamp: 'tak 6/27/2004 18:35'!
primDBodyGetAngularVel: bodyID into: vec 
	<primitive: 'primitiveDBodyGetAngularVel' module: 'ODEPlugin'>
	self primitiveFailed! !

!ODE methodsFor: 'primitives rigid ' stamp: 'tak 6/27/2004 18:35'!
primDBodyGetForce: bodyID into: vec 
	<primitive: 'primitiveDBodyGetForce' module: 'ODEPlugin'>
	self primitiveFailed! !

!ODE methodsFor: 'primitives rigid ' stamp: 'tak 6/27/2004 18:35'!
primDBodyGetLinearVel: bodyID into: vec 
	<primitive: 'primitiveDBodyGetLinearVel' module: 'ODEPlugin'>
	self primitiveFailed! !

!ODE methodsFor: 'primitives rigid ' stamp: 'tak 6/27/2004 18:36'!
primDBodyGetPosition: bodyId into: vec 
	<primitive: 'primitiveDBodyGetPosition' module: 'ODEPlugin'>
	self primitiveFailed! !

!ODE methodsFor: 'primitives rigid ' stamp: 'tak 6/28/2004 11:23'!
primDBodyGetQuaternion: bodyID into: vec
	<primitive: 'primitiveDBodyGetQuaternion' module: 'ODEPlugin'>
	self primitiveFailed! !

!ODE methodsFor: 'primitives rigid ' stamp: 'tak 6/28/2004 23:39'!
primDBodySetAngularVel: bodyID with: x with: y with: z 
	<primitive: 'primitiveDBodySetAngularVel' module: 'ODEPlugin'>
	self primitiveFailed! !

!ODE methodsFor: 'primitives rigid ' stamp: 'tak 6/28/2004 18:23'!
primDBodySetFiniteRotationAxis: bodyID with: x with: y with: z 
	<primitive: 'primitiveDBodySetFiniteRotationAxis' module: 'ODEPlugin'>
	^ self primitiveFailed! !

!ODE methodsFor: 'primitives rigid ' stamp: 'tak 6/28/2004 18:20'!
primDBodySetFiniteRotationMode: bodyID with: mode 
	<primitive: 'primitiveDBodySetFiniteRotationMode' module: 'ODEPlugin'>
	^ self primitiveFailed! !

!ODE methodsFor: 'primitives rigid ' stamp: 'tak 6/28/2004 23:39'!
primDBodySetLinearVel: bodyID with: x with: y with: z 
	<primitive: 'primitiveDBodySetLinearVel' module: 'ODEPlugin'>
	self primitiveFailed! !

!ODE methodsFor: 'primitives rigid ' stamp: 'tak 6/28/2004 01:44'!
primDBodySetMassSphere: bodyID with: radius
	<primitive: 'primitiveDBodySetMassSphere' module: 'ODEPlugin'>
	self primitiveFailed! !

!ODE methodsFor: 'primitives rigid ' stamp: 'tak 6/27/2004 18:36'!
primDBodySetPosition: bodyID with: x with: y with: z
	<primitive: 'primitiveDBodySetPosition' module: 'ODEPlugin'>
	^ self primitiveFailed! !

!ODE methodsFor: 'primitives rigid ' stamp: 'tak 6/28/2004 17:56'!
primDBodySetQuaternion: bodyID with: aFloatArray
	<primitive: 'primitiveDBodySetQuaternion' module: 'ODEPlugin'>
	self primitiveFailed! !

!ODE methodsFor: 'primitives rigid ' stamp: 'tak 6/27/2004 18:36'!
primDJointGroupEmpty: jointGroupID 
	<primitive: 'primitiveDJointGroupEmpty' module: 'ODEPlugin'>
	self primitiveFailed! !


!ODE methodsFor: 'primitive world' stamp: 'tak 6/27/2004 18:36'!
primDWorldCreate
	<primitive: 'primitiveDWorldCreate' module: 'ODEPlugin'>
	self primitiveFailed! !

!ODE methodsFor: 'primitive world' stamp: 'tak 6/27/2004 18:36'!
primDWorldDestroy: worldHandle
	<primitive: 'primitiveDWorldDestroy' module: 'ODEPlugin'>
	self primitiveFailed! !

!ODE methodsFor: 'primitive world' stamp: 'tak 6/27/2004 18:36'!
primDWorldQuickStep: worldHandle with: stepSize
	<primitive: 'primitiveDWorldQuickStep' module: 'ODEPlugin'>
	self primitiveFailed! !

!ODE methodsFor: 'primitive world' stamp: 'tak 6/27/2004 18:36'!
primDWorldSetGravity: worldHandle with: x with: y with: z
	<primitive: 'primitiveDWorldSetGravity' module: 'ODEPlugin'>
	self primitiveFailed! !


SmartSyntaxInterpreterPlugin subclass: #ODEPlugin
	instanceVariableNames: 'lastGeomIDList lastGeomIDListSize lastGeomIDListIndex '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ODE'!

!ODEPlugin methodsFor: 'primitives geom' stamp: 'tak 6/28/2004 14:45'!
primitiveDCreateBox: spaceID with: x with: y with: z
	| geomID |
	self primitive: 'primitiveDCreateBox' parameters: #(#SmallInteger #Float #Float #Float ).
	geomID _ self cCode: ' (int) dCreateBox ((void *) spaceID, (dReal) x, (dReal) y, (dReal) z)'.
	^ geomID asOop: SmallInteger
! !

!ODEPlugin methodsFor: 'primitives geom' stamp: 'tak 6/27/2004 11:38'!
primitiveDCreatePlane: spaceID with: a with: b with: c with: d 
	| geomID |
	self primitive: 'primitiveDCreatePlane' parameters: #(#SmallInteger #Float #Float #Float #Float ).
	geomID _ self cCode: ' (int) dCreatePlane ((void *) spaceID, (dReal) a, (dReal) b, (dReal) c, (dReal) d)'.
	^ geomID asOop: SmallInteger
! !

!ODEPlugin methodsFor: 'primitives geom' stamp: 'tak 6/27/2004 11:32'!
primitiveDCreateSphere: spaceID with: radius
	| geomID |
	self primitive: 'primitiveDCreateSphere' parameters: #(#SmallInteger #Float).
	geomID _ self cCode: ' (int) dCreateSphere ((void *) spaceID, (dReal) radius)'.
	^ geomID asOop: SmallInteger
! !

!ODEPlugin methodsFor: 'primitives geom' stamp: 'tak 6/28/2004 14:48'!
primitiveDGeomBoxSetLengths: geomID with: x with: y with: z
	self primitive: 'primitiveDGeomBoxSetLengths' parameters: #(#SmallInteger #Float #Float #Float ).
	self cCode: 'dGeomBoxSetLengths ((dGeomID) geomID, (dReal) x, (dReal) y, (dReal) z)'.
! !

!ODEPlugin methodsFor: 'primitives geom' stamp: 'tak 6/27/2004 03:12'!
primitiveDGeomDestroy: geomID
	self primitive: 'primitiveDGeomDestroy' parameters: #(#SmallInteger).
	self cCode: ' dGeomDestroy ((void *) geomID)'.
! !

!ODEPlugin methodsFor: 'primitives geom' stamp: 'tak 6/26/2004 20:32'!
primitiveDGeomSetBody: geomId with: bodyId
	self primitive: 'primitiveDGeomSetBody' parameters: #(#SmallInteger #SmallInteger).
	self cCode: ' dGeomSetBody ((void *) geomId, (void *) bodyId)'.
! !

!ODEPlugin methodsFor: 'primitives geom' stamp: 'tak 6/28/2004 01:46'!
primitiveDGeomSphereSetRadius: geomID with: radius
	self primitive: 'primitiveDGeomSphereSetRadius' parameters: #(#SmallInteger #Float).
	self cCode: 'dGeomSphereSetRadius  ((void *) geomID, (dReal) radius)'.
! !


!ODEPlugin methodsFor: 'primitives collision ' stamp: 'tak 6/28/2004 17:49'!
nearCallback: data with: o1 with: o2 
	self var: #data type: 'void *'.
	self var: #o1 type: 'dGeomID'.
	self var: #o2 type: 'dGeomID'.
	self returnTypeC: 'void'.
	lastGeomIDListIndex < lastGeomIDListSize
		ifFalse: [
			lastGeomIDListSize _ lastGeomIDListSize + 100.
			lastGeomIDList _ self cCode: ' (dGeomID *) realloc( lastGeomIDList, lastGeomIDListSize * sizeof (dGeomID))'].
	lastGeomIDList = (self cCode: 'NULL')
		ifTrue: [interpreterProxy primitiveFail].
	lastGeomIDList at: lastGeomIDListIndex put: o1.
	lastGeomIDList at: lastGeomIDListIndex + 1 put: o2.
	lastGeomIDListIndex _ lastGeomIDListIndex + 2! !

!ODEPlugin methodsFor: 'primitives collision ' stamp: 'tak 6/28/2004 17:27'!
primitiveDHashSpaceCreate: spaceID
	"spaceID is a dSpaceID or zero"
	| newSpaceID |
	self primitive: 'primitiveDHashSpaceCreate' parameters: #(#SmallInteger).
	newSpaceID _ self cCode: ' (int) dHashSpaceCreate  ((dSpaceID) spaceID)'.
	^ newSpaceID asOop: SmallInteger
! !

!ODEPlugin methodsFor: 'primitives collision ' stamp: 'tak 6/28/2004 17:27'!
primitiveDJointDestroy: jointID
	self primitive: 'primitiveDJointDestroy' parameters: #(#SmallInteger ).
	self cCode: ' dJointDestroy ((dJointID) jointID)'! !

!ODEPlugin methodsFor: 'primitives collision ' stamp: 'tak 6/26/2004 20:17'!
primitiveDJointGroupCreate
	"spaceId is a dSpaceId or zero"
	| jointGroupId |
	self primitive: 'primitiveDJointGroupCreate' parameters: #().
	jointGroupId _ self cCode: ' (int) dJointGroupCreate (0)'.
	^ jointGroupId asOop: SmallInteger
! !

!ODEPlugin methodsFor: 'primitives collision ' stamp: 'tak 6/28/2004 19:05'!
primitiveDJointGroupDestroy:  jointGoupID 
	"void why??"
	self primitive: 'primitiveDJointGroupDestroy' parameters: #(#SmallInteger ).
	self cCode: ' dJointGroupDestroy  ((void *) jointGoupID)'! !

!ODEPlugin methodsFor: 'primitives collision ' stamp: 'tak 6/28/2004 17:29'!
primitiveDSpaceCollide: spaceID 
	"return array of collided id as #(o1 o2 o1 o2 o1 o2 ...)"
	| array |
	self primitive: 'primitiveDSpaceCollide' parameters: #(#SmallInteger ).
	lastGeomIDListIndex _ 0.
	lastGeomIDListSize _ 100.
	lastGeomIDList _ self cCode: ' (dGeomID *) malloc(lastGeomIDListSize * sizeof (dGeomID))'.
	lastGeomIDList = (self cCode: 'NULL')
		ifTrue: [^ interpreterProxy primitiveFail].
	self cCode: ' dSpaceCollide ((void *) spaceID, NULL, nearCallbackwithwith)'.
	array _ interpreterProxy instantiateClass: interpreterProxy classArray indexableSize: lastGeomIDListIndex.
	0 to: lastGeomIDListIndex - 1
		do: [:i | interpreterProxy
				storePointer: i
				ofObject: array
				withValue: (self cCode: '(int) (lastGeomIDList[i])') asSmallIntegerObj].
	lastGeomIDListIndex _ 0.
	lastGeomIDListSize _ 0.
	self cCode: ' free(lastGeomIDList)'.
	^ array! !

!ODEPlugin methodsFor: 'primitives collision ' stamp: 'tak 6/28/2004 19:04'!
primitiveDSpaceDestroy: spaceID 
	"void why??"
	self primitive: 'primitiveDSpaceDestroy' parameters: #(#SmallInteger ).
	self cCode: ' dSpaceDestroy((void *) spaceID)'! !

!ODEPlugin methodsFor: 'primitives collision ' stamp: 'tak 6/27/2004 14:07'!
primitiveMakeContact: o1 with: o2 world: world group: group bounce: bounce bounceVel: bounceVel softCFM: softCFM 
	| b1 b2 numc contact |
	self primitive: 'primitiveMakeContact' parameters: #(#SmallInteger #SmallInteger #SmallInteger #SmallInteger #Float #Float #Float ).
	self var: 'b1' type: 'dBodyID'.
	self var: 'b2' type: 'dBodyID'.
	self var: 'contact' declareC: 'dContact contact[4]'.
	b1 _ self cCode: ' dGeomGetBody((dGeomID) o1)'.
	b2 _ self cCode: ' dGeomGetBody((dGeomID) o2)'.
	0 to: 4 - 1
		do: [:i | self cCode: '
			contact[i].surface.mode = dContactBounce | dContactSoftCFM;
			contact[i].surface.mu = dInfinity;
			contact[i].surface.mu2 = 0;
			contact[i].surface.bounce = (dReal) bounce;
			contact[i].surface.bounce_vel = (dReal) bounceVel;
			contact[i].surface.soft_cfm = (dReal) softCFM;'].
	numc _ self cCode: 'dCollide ((dGeomID) o1, (dGeomID) o2, 4,&contact[0].geom, sizeof(dContact))'.
	numc > 0
		ifTrue: [0 to: numc - 1
				do: [:i | self cCode: '
				dJointID c = dJointCreateContact ((dWorldID) world, (dJointGroupID) group, contact + i);
				dJointAttach (c, b1 ,b2);']]! !


!ODEPlugin methodsFor: 'primitives rigid ' stamp: 'tak 6/28/2004 23:31'!
primitiveDBodyAddForce: bodyID with: x with: y with: z 
	self primitive: 'primitiveDBodyAddForce:' parameters: #(#SmallInteger #Float #Float #Float ).
	self cCode: ' dBodyAddForce ((dBodyID) bodyID, (dReal) x, (dReal) y, (dReal) z)'! !

!ODEPlugin methodsFor: 'primitives rigid ' stamp: 'tak 6/28/2004 23:32'!
primitiveDBodyAddTorque: bodyID with: x with: y with: z 
	self primitive: 'primitiveDBodyAddTorque' parameters: #(#SmallInteger #Float #Float #Float ).
	self cCode: ' dBodyAddTorque ((dBodyID) bodyID, (dReal) x, (dReal) y, (dReal) z)'! !

!ODEPlugin methodsFor: 'primitives rigid ' stamp: 'tak 6/28/2004 17:24'!
primitiveDBodyCreate: worldID
	| bodyID |
	self primitive: 'primitiveDBodyCreate:' parameters: #(#SmallInteger).
	bodyID _ self cCode: ' (int) dBodyCreate ((dWorldID) worldID)'.
	^ bodyID asOop: SmallInteger
! !

!ODEPlugin methodsFor: 'primitives rigid ' stamp: 'tak 6/28/2004 23:25'!
primitiveDBodyGetAngularVel: bodyID into: vec
	self primitive: 'primitiveDBodyGetAngularVel' parameters: #(#SmallInteger #Oop ).
	self returnArray: (self cCode: ' dBodyGetAngularVel ((dBodyID) bodyID)') into: vec size: 3
! !

!ODEPlugin methodsFor: 'primitives rigid ' stamp: 'tak 6/28/2004 23:25'!
primitiveDBodyGetForce: bodyID into: vec
	self primitive: 'primitiveDBodyGetForce' parameters: #(#SmallInteger #Oop ).
	self returnArray: (self cCode: ' dBodyGetForce ((dBodyID) bodyID)') into: vec size: 3
! !

!ODEPlugin methodsFor: 'primitives rigid ' stamp: 'tak 6/28/2004 23:24'!
primitiveDBodyGetLinearVel: bodyID into: vec
	self primitive: 'primitiveDBodyGetLinearVel' parameters: #(#SmallInteger #Oop ).
	self returnArray: (self cCode: ' dBodyGetLinearVel ((dBodyID) bodyID)') into: vec size: 3
! !

!ODEPlugin methodsFor: 'primitives rigid ' stamp: 'tak 6/28/2004 23:20'!
primitiveDBodyGetPosition: bodyID into: vec 
	self primitive: 'primitiveDBodyGetPosition' parameters: #(#SmallInteger #Oop ).
	self returnArray: (self cCode: ' dBodyGetPosition ((dBodyID) bodyID)') into: vec size: 3
! !

!ODEPlugin methodsFor: 'primitives rigid ' stamp: 'tak 6/28/2004 23:26'!
primitiveDBodyGetQuaternion: bodyID into: vec
	self primitive: 'primitiveDBodyGetQuaternion' parameters: #(#SmallInteger #Oop ).
	self returnArray: (self cCode: ' dBodyGetQuaternion ((dBodyID) bodyID)') into: vec size: 4
! !

!ODEPlugin methodsFor: 'primitives rigid ' stamp: 'tak 6/28/2004 23:37'!
primitiveDBodySetAngularVel: bodyID with: x with: y with: z 
	self primitive: 'primitiveDBodySetAngularVel' parameters: #(#SmallInteger #Float #Float #Float ).
	self cCode: ' dBodySetAngularVel ((dBodyID) bodyID, (dReal) x, (dReal) y, (dReal) z)'! !

!ODEPlugin methodsFor: 'primitives rigid ' stamp: 'tak 6/28/2004 18:23'!
primitiveDBodySetFiniteRotationAxis: bodyID with: x with: y with: z 
	self primitive: 'primitiveDBodySetFiniteRotationAxis' parameters: #(#SmallInteger #Float #Float #Float ).
	self cCode: ' dBodySetFiniteRotationAxis ((dBodyID) bodyID, (dReal) x, (dReal) y, (dReal) z)'! !

!ODEPlugin methodsFor: 'primitives rigid ' stamp: 'tak 6/28/2004 18:20'!
primitiveDBodySetFiniteRotationMode: bodyID with: mode 
	self primitive: 'primitiveDBodySetFiniteRotationMode' parameters: #(#SmallInteger #SmallInteger ).
	self cCode: ' dBodySetFiniteRotationMode ((dBodyID) bodyID, mode)'! !

!ODEPlugin methodsFor: 'primitives rigid ' stamp: 'tak 6/28/2004 23:36'!
primitiveDBodySetLinearVel: bodyID with: x with: y with: z 
	self primitive: 'primitiveDBodySetLinearVel' parameters: #(#SmallInteger #Float #Float #Float ).
	self cCode: ' dBodySetLinearVel ((dBodyID) bodyID, (dReal) x, (dReal) y, (dReal) z)'! !

!ODEPlugin methodsFor: 'primitives rigid ' stamp: 'tak 6/28/2004 17:25'!
primitiveDBodySetMassSphere: bodyID with: radius
	| density mass |
	self primitive: 'primitiveDBodySetMassSphere' parameters: #(#SmallInteger #Float).
	self var: 'density' type: 'dReal'.
	self var: 'mass' type: 'dMass'.
	density _ 1.0.
	self cCode: 'dMassSetSphere (&mass, density, radius)'.
	self cCode: 'dBodySetMass ((dBodyID) bodyID, &mass)'.
! !

!ODEPlugin methodsFor: 'primitives rigid ' stamp: 'tak 6/28/2004 17:25'!
primitiveDBodySetPosition: bodyID with: x with: y with: z
	self primitive: 'primitiveDBodySetPosition' parameters: #(#SmallInteger Float Float Float).
	self cCode: ' dBodySetPosition ((dBodyID) bodyID, (dReal) x, (dReal) y, (dReal) z)'.
! !

!ODEPlugin methodsFor: 'primitives rigid ' stamp: 'tak 6/28/2004 17:53'!
primitiveDBodySetQuaternion: bodyID with: q
	| qua |
	self primitive: 'primitiveDBodySetQuaternion' parameters: #(#SmallInteger FloatArray).
	self var: 'qua' type: 'dQuaternion'.
	qua at: 0 put: (q at: 0).
	qua at: 1 put: (q at: 1).
	qua at: 2 put: (q at: 2).
	qua at: 3 put: (q at: 3).
	self cCode: ' dBodySetQuaternion ((dBodyID) bodyID, qua)'.
! !

!ODEPlugin methodsFor: 'primitives rigid ' stamp: 'tak 6/28/2004 17:25'!
primitiveDJointGroupEmpty: jointGroupID 
	self primitive: 'primitiveDJointGroupEmpty' parameters: #(#SmallInteger ).
	self cCode: ' dJointGroupEmpty ((dJointGroupID) jointGroupID)'! !

!ODEPlugin methodsFor: 'primitives rigid ' stamp: 'tak 6/28/2004 23:26'!
returnArray: answer into: array size: size
	| pArray |
	self returnTypeC: 'void'.
	self var: 'answer' type: 'dReal *'.
	self var: 'pArray' type: 'float *'.
	pArray _ self cCoerce: (interpreterProxy firstIndexableField: array) to: 'float *'.
	0 to: size - 1 do: [:i |
		pArray at: i put: (answer at: i)]
! !


!ODEPlugin methodsFor: 'primitive world' stamp: 'tak 6/28/2004 17:24'!
primitiveDWorldCreate
	| worldID |
	 self primitive: 'primitiveDWorldCreate' parameters: #().
	worldID _ self cCode: ' (int) dWorldCreate()'.
	^worldID asOop: SmallInteger! !

!ODEPlugin methodsFor: 'primitive world' stamp: 'tak 6/28/2004 19:06'!
primitiveDWorldDestroy: worldID 
	"void why??"
	self primitive: 'primitiveDWorldDestroy' parameters: #(#SmallInteger ).
	self cCode: ' dWorldDestroy((void *) worldID)'! !

!ODEPlugin methodsFor: 'primitive world' stamp: 'tak 6/28/2004 17:14'!
primitiveDWorldQuickStep: worldID with: stepSize
	self primitive: 'primitiveDWorldQuickStep' parameters: #(#SmallInteger Float).
	self cCode: ' dWorldQuickStep ((dWorldID) worldID, (dReal) stepSize)'.
! !

!ODEPlugin methodsFor: 'primitive world' stamp: 'tak 6/28/2004 17:23'!
primitiveDWorldSetGravity: worldID with: x with: y with: z
	self primitive: 'primitiveDWorldSetGravity' parameters: #(#SmallInteger Float Float Float ).
	self cCode: ' dWorldSetGravity ((dWorldID) worldID, (dReal) x, (dReal) y, (dReal) z)'.
! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ODEPlugin class
	instanceVariableNames: ''!

!ODEPlugin class methodsFor: 'translation' stamp: 'tak 6/27/2004 01:22'!
declareCVarsIn: cg
	cg addHeaderFile:'<ode/ode.h>'.
	cg var: #lastGeomIDList type: #'dGeomID *'.
	cg var: #lastGeomIDListSize type: #'size_t'.
	cg var: #lastGeomIDListIndex type: #'int'.
! !


Morph subclass: #ODETestMorph
	instanceVariableNames: 'elements ode world space group planes '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ODE'!
!ODETestMorph commentStamp: 'tak 6/29/2004 00:25' prior: 0!
self new elements: {Morph}; openInHand.
self new elements: {EllipseMorph}; openInHand
self new elements: {StarMorph}; openInHand.
self new elements: {Morph. EllipseMorph. StarMorph}; openInHand.

!


!ODETestMorph methodsFor: 'initialization' stamp: 'tak 6/29/2004 00:03'!
build
	ode ifNotNil: [^self].
	ode _ ODE new.
	world _ ode primDWorldCreate.
	space _ ode primDHashSpaceCreate: 0.
	group _ ode primDJointGroupCreate.
	ode primDWorldSetGravity: world with: 0.0 with: 0.7 with: 0.0.
	self setPlanes

! !

!ODETestMorph methodsFor: 'initialization' stamp: 'tak 6/27/2004 14:55'!
defaultBounds
	^ 0@0 corner: 200@200! !

!ODETestMorph methodsFor: 'initialization' stamp: 'tak 6/27/2004 18:30'!
defaultColor
	^ Color black! !

!ODETestMorph methodsFor: 'initialization' stamp: 'tak 6/27/2004 16:39'!
delete
	self destroy.
	super delete.! !

!ODETestMorph methodsFor: 'initialization' stamp: 'tak 6/27/2004 15:19'!
destroy
	self stopStepping.
	ode ifNil: [^self].
	ode primDJointGroupDestroy: group.
	ode primDSpaceDestroy: space.
	ode primDWorldDestroy: world.
	ode _ space _ world _ group _ nil.
	self removeAllMorphs
! !

!ODETestMorph methodsFor: 'initialization' stamp: 'tak 6/29/2004 00:24'!
initialize
	super initialize.
	self elements: {EllipseMorph}.
	self enableDragNDrop: true.
	self build.! !


!ODETestMorph methodsFor: 'event handling' stamp: 'tak 6/27/2004 16:41'!
handlesMouseDown: evt
	^ true! !

!ODETestMorph methodsFor: 'event handling' stamp: 'tak 6/27/2004 16:43'!
mouseDown: evt
	self add: evt position.! !


!ODETestMorph methodsFor: 'accessing' stamp: 'tak 6/27/2004 16:43'!
add
	self add: self center.! !

!ODETestMorph methodsFor: 'accessing' stamp: 'tak 6/29/2004 00:22'!
add: pos 
	| morph body geom |
	morph _ self elementMorphClass new.
	self addMorph: morph.
	morph position: pos.
	morph borderWidth: 0.
	morph extent: 20.0.
	body _ ode primDBodyCreate: world.
	geom _ ({EllipseMorph. StarMorph} includes: morph)
				ifTrue: [ode primDCreateSphere: space with: 1.0]
				ifFalse: [ode
						primDCreateBox: space
						with: 2.0
						with: 2.0
						with: 2.0].
	ode primDBodySetFiniteRotationMode: body with: 1. 
	ode primDBodySetFiniteRotationAxis: body with: 0.0 with: 0.0 with: 1.0. 

	ode primDBodySetMassSphere: body with: 5.0.
	ode primDGeomSetBody: geom with: body.
	morph setProperty: #body toValue: body.
	morph setProperty: #geom toValue: geom.
morph on: #mouseDown send: #grabMorph: to: morph.
	self getAllPosition! !

!ODETestMorph methodsFor: 'accessing' stamp: 'tak 6/29/2004 00:19'!
elementMorphClass
	| morphClass |
	morphClass _ elements first.
	elements _ elements allButFirst, {morphClass}.
	^ morphClass! !

!ODETestMorph methodsFor: 'accessing' stamp: 'tak 6/29/2004 00:17'!
elements: morphs
	elements _ morphs! !

!ODETestMorph methodsFor: 'accessing' stamp: 'tak 6/27/2004 18:49'!
extent: aPoint
	super extent: aPoint.
	self setPlanes! !

!ODETestMorph methodsFor: 'accessing' stamp: 'tak 6/28/2004 23:42'!
getAllPosition
	| body pos quaternion vel |
	self
		submorphsDo: [:m | 
			body _ m renderedMorph valueOfProperty: #body.
			body
				ifNotNil: [
					pos _ m center / 10.0.
					ode
						primDBodySetPosition: body
						with: pos x
						with: pos y
						with: 0.0.
					quaternion _ ode dBodyGetQuaternion: body.
					ode primDBodySetQuaternion: body with: {quaternion first. 0. 0. quaternion fourth} asFloatArray.
			vel _ ode dBodyGetLinearVel: body.
			ode primDBodySetLinearVel: body with: vel first with: vel second with: 0.0.



]]! !

!ODETestMorph methodsFor: 'accessing' stamp: 'tak 6/27/2004 18:47'!
position: aPoint
	super position: aPoint.
	self setPlanes! !

!ODETestMorph methodsFor: 'accessing' stamp: 'tak 6/28/2004 19:13'!
setAllPosition
	| body pos velocity angular quaternion |
	self
		submorphsDo: [:m | 
			body _ m renderedMorph valueOfProperty: #body.
			body
				ifNotNil: [
					pos _ ode dBodyGetPosition: body.
					m center: (pos at: 1) * 10 @ ((pos at: 2) * 10).
					velocity _ ode dBodyGetLinearVel: body.
					angular _ ode dBodyGetAngularVel: body.
					quaternion _ ode dBodyGetQuaternion: body.
"(pos at: 3) = 0 ifFalse: [Transcript show: (pos at: 3) printString; cr]."
"Transcript show: pos printString; cr."
"(quaternion second = 0 and: [quaternion third = 0]) ifFalse: [
Transcript show: quaternion printString; cr.]."
					self setHeading: m to: quaternion first arcCos radiansToDegrees * 2.
					m renderedMorph color: (Color
							h: 360 - (angular length * 40 min: 360)
							s: 0.7
							v: (velocity length / 2.0 min: 1.0))]]! !

!ODETestMorph methodsFor: 'accessing' stamp: 'tak 6/28/2004 15:41'!
setHeading: aMorph to: degree

	aMorph class = EllipseMorph ifTrue: [^self].
	aMorph heading: degree.
"Transcript show: degree; cr"
! !

!ODETestMorph methodsFor: 'accessing' stamp: 'tak 6/27/2004 18:18'!
setPlanes
	| origin corner |
	ode
		ifNil: [
			planes _ nil.
			^ self].
	planes
		ifNotNil: [
			planes
				do: [:plane | ode primDGeomDestroy: plane].
			planes _ nil].
	origin _ (self bounds expandBy: 10) origin / 10.0.
	corner _ (self bounds expandBy: 10) corner / 10.0.
	planes _ Array new: 4.
	planes at: 1 put: (ode
			primDCreatePlane: space
			with: 0.0
			with: 1.0
			with: 0.0
			with: origin y).
	planes at: 2 put: (ode
			primDCreatePlane: space
			with: 0.0
			with: -1.0
			with: 0.0
			with: corner y negated).
	planes at: 3 put: (ode
			primDCreatePlane: space
			with: 1.0
			with: 0.0
			with: 0.0
			with: origin x).
	planes at: 4 put: (ode
			primDCreatePlane: space
			with: -1.0
			with: 0.0
			with: 0.0
			with: corner x negated)! !

!ODETestMorph methodsFor: 'accessing' stamp: 'tak 6/29/2004 00:01'!
step
	ode
		ifNil: [
			self stopStepping.
			^ self].
	self getAllPosition.
	ode dSpaceCollide: space
		do: [:geom1 :geom2 | ode
				primMakeContact: geom1
				with: geom2
				world: world
				group: group
				bounce: 1.0
				bounceVel: 1.0
				softCFM: 0.0].
	ode dWorldQuickStep: world with: 0.3.
	ode dJointGroupEmpty: group.
	self setAllPosition! !

!ODETestMorph methodsFor: 'accessing' stamp: 'tak 6/29/2004 00:28'!
stepTime
	^ 50! !


ODETestMorph subclass: #ODETestBoxMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ODE'!

!ODETestBoxMorph methodsFor: 'accessing' stamp: 'tak 6/28/2004 10:05'!
elementMorphClass
	^ Morph
! !
